<?php

/*
 * Fakturama - Free Invoicing Software - http://www.fakturama.org
 * 
 * 
 * Web shop connector script
 */
define('FAKTURAMA_CONNECTOR_VERSION', '2.0');
/*
 * Date: 2018-02-07
 * 
 * modified shop 2.x Connector
 *
 * minimum required PHP version is 5.4
 * following requirements of modified 2.x
 * tested up to PHP 7.1
 * 
 * based on:
 * 
 * 
 * Date: 2015-02-21
 * 
 * This version is compatible to the same version of Fakturama
 *
 *
 * 
 * Copyright (C) 2011 Gerd Bartelt
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Gerd Bartelt - initial API and implementation
 */

// Character Set of the web shop. This is used to send notification comments.
define('FAKTURAMA_WEBSHOP_CHARSET', 'UTF-8');

// Only for debugging. All the data is encrypted.
//define ('ENCRYPT_DATA',true); 
// Set header to UTF-8
header("Content-Type: text/html; charset=utf-8");

// Set the level of error reporting
error_reporting(E_ALL & ~E_NOTICE);

// Include application configuration parameters
require('includes/configure.php');

// security
define('_VALID_XTC', true);

define('LANG_DIR', '../lang/');

// Include required functions
//  MODIFIED-SHOP
if (file_exists(DIR_FS_INC . 'html_encoding.php')) {
  require_once(DIR_FS_INC . 'html_encoding.php');
}
//  GAMBIO // needs to be tested 
if (file_exists(DIR_FS_INC . 'htmlspecialchars_wrapper.inc.php')) {
  require_once(DIR_FS_INC . 'htmlspecialchars_wrapper.inc.php');
}
if (file_exists(DIR_FS_INC . 'htmlentities_wrapper.inc.php')) {
  require_once(DIR_FS_INC . 'htmlentities_wrapper.inc.php');
}

require_once(DIR_FS_INC . 'db_functions_' . DB_MYSQL_TYPE . '.inc.php');
require_once(DIR_FS_INC . 'db_functions.inc.php');
require_once(DIR_FS_INC . 'xtc_not_null.inc.php');


// TODO - check if it works for mod 2.x
if (file_exists(DIR_FS_EXTERNAL . 'smarty/smarty_2/Smarty.class.php')) {
  require(DIR_FS_EXTERNAL . 'smarty/smarty_2/Smarty.class.php');
} else {
  exit_with_error("No valid Smarty.class.php found.");
}

require_once(DIR_FS_EXTERNAL . 'phpmailer/PHPMailerAutoload.php');
require_once(DIR_FS_INC . 'xtc_php_mail.inc.php');


// include the mail classes
function sbf_php_mail($from_email_address, $from_email_name, $to_email_address, $to_name, $forwarding_to, $reply_address, $reply_address_name, $path_to_attachement, $path_to_more_attachements, $email_subject, $message_body_html, $message_body_plain, $order_language) {
  global $mail_error;

  $mailsmarty = new Smarty;
  $mailsmarty->compile_dir = DIR_FS_DOCUMENT_ROOT . 'templates_c';

// Check for existing signature files
// load the signatures only, if the appropriate file(s) exists
  $html_signatur = '';
  $txt_signatur = '';
  if (file_exists(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/signatur.html')) {
    $html_signatur = $mailsmarty->fetch(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/signatur.html');
  }

  if (file_exists(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/signatur.txt')) {
    $txt_signatur = $mailsmarty->fetch(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/signatur.txt');
  }

//Widerruf in Email
  $html_widerruf = '';
  $txt_widerruf = '';
  if (file_exists(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/widerruf.html')) {
    $html_widerruf = $mailsmarty->fetch(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/widerruf.html');
  }

  if (file_exists(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/widerruf.txt')) {
    $txt_widerruf = $mailsmarty->fetch(DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/mail/' . $order_language . '/widerruf.txt');
  }

//Platzhalter [WIDERRUF] durch Widerruf Text ersetzen
  if (strpos($message_body_html, '[WIDERRUF]') !== false) {
    $message_body_html = str_replace('[WIDERRUF]', $html_widerruf, $message_body_html);
  }

  if (strpos($message_body_plain, '[WIDERRUF]') !== false) {
    $message_body_plain = str_replace('[WIDERRUF]', $txt_widerruf, $message_body_plain);
  }

//Platzhalter [SIGNATUR] durch Signatur Text ersetzen
  if (strpos($message_body_html, '[SIGNATUR]') !== false) {
    $message_body_html = str_replace('[SIGNATUR]', $html_signatur, $message_body_html);
    $html_signatur = '';
  }

  if (strpos($message_body_plain, '[SIGNATUR]') !== false) {
    $message_body_plain = str_replace('[SIGNATUR]', $txt_signatur, $message_body_plain);
    $txt_signatur = '';
  }

//**********************************************************************************************

  $mail = new PHPMailer();
  $mail->PluginDir = DIR_FS_DOCUMENT_ROOT . 'includes/classes/';

  if (isset($_SESSION['language_charset'])) {
    $mail->CharSet = $_SESSION['language_charset'];
  } else {
    $lang_query = "SELECT * FROM languages WHERE code = '" . DEFAULT_LANGUAGE . "'";
    $lang_query = xtc_db_query($lang_query);
    $lang_data = xtc_db_fetch_array($lang_query);
    $mail->CharSet = $lang_data['language_charset'];
  }
//SetLanguage Multilanguage
  if (isset($_SESSION['language_code'])) {
    $lang_code = $_SESSION['language_code'];
  } else {
    $lang_code = DEFAULT_LANGUAGE;
  }




  $mail->SetLanguage($lang_code, DIR_WS_CLASSES);

  if (EMAIL_TRANSPORT == 'smtp') {
    $mail->IsSMTP();
    $mail->SMTPKeepAlive = true; // set mailer to use SMTP
    $mail->SMTPAuth = SMTP_AUTH; // turn on SMTP authentication true/false
    $mail->Username = SMTP_USERNAME; // SMTP username
    $mail->Password = SMTP_PASSWORD; // SMTP password
    $mail->Host = SMTP_MAIN_SERVER . ';' . SMTP_Backup_Server; // specify main and backup server "smtp1.example.com;smtp2.example.com"
  }

  if (EMAIL_TRANSPORT == 'sendmail') { // set mailer to use SMTP
    $mail->IsSendmail();
    $mail->Sendmail = SENDMAIL_PATH;
  }

  if (EMAIL_TRANSPORT == 'mail') {
    $mail->IsMail();
  }

  if (EMAIL_USE_HTML == 'true') { // set email format to HTML
    $mail->IsHTML(true);
    $mail->Body = $message_body_html . $html_signatur; //DPW Signatur ergänzt.
// remove html tags
    $message_body_plain = str_replace('<br />', " \n", $message_body_plain . $txt_signatur); //DPW Signatur ergänzt.
    $message_body_plain = strip_tags($message_body_plain);
    $mail->AltBody = $message_body_plain;
  } else {
    $mail->IsHTML(false);
//remove html tags
    $message_body_plain = str_replace('<br />', " \n", $message_body_plain . $txt_signatur); //DPW Signatur ergänzt.
    $message_body_plain = strip_tags($message_body_plain);
    $mail->Body = $message_body_plain;
  }


  $mail->From = $from_email_address;
  $mail->Sender = $from_email_address;
  $mail->FromName = $from_email_name;
  $mail->AddAddress($to_email_address, $to_name);
  if ($forwarding_to != '') {
    $mail->AddBCC($forwarding_to);
  }
  $mail->AddReplyTo($reply_address, $reply_address_name);

  $mail->WordWrap = 50; // set word wrap to 50 characters
  $mail->Subject = $email_subject;

  if (!$mail->Send()) {
    return "Error sending email to: \"" . $to_email_address . "\" - " . $mail->ErrorInfo;
  }

  return "";
}

// make a connection to the database... now
xtc_db_connect() or die('Unable to connect to database server!');

// set application wide parameters
$configuration_query = xtc_db_query("SELECT configuration_key AS cfgKey,
                                            configuration_value AS cfgValue
                                       FROM configuration
                                    ");
while ($configuration = xtc_db_fetch_array($configuration_query)) {
  $configuration_array[$configuration['cfgKey']] = $configuration['cfgValue'];
  define($configuration['cfgKey'], $configuration['cfgValue']);
}


// Define our general functions used application-wide
require (DIR_WS_FUNCTIONS . 'general.php');
require (DIR_WS_FUNCTIONS . 'html_output.php');

// Return true if $str ends with $sub
function endsWith($str, $sub) {
  return ( substr($str, strlen($str) - strlen($sub)) == $sub );
}

//Return true if $str starts with $sub
function startsWith($str, $sub) {
  return substr($str, 0, strlen($sub)) == $sub;
}

// Encrypt the data
function my_encrypt($s) {
// Replace all characters
  if (defined('ENCRYPT_DATA')) {
    $s = preg_replace("/[a-z]/", "x", $s);
    $s = preg_replace("/[A-Z]/", "X", $s);
    $s = preg_replace("/[0-9]/", "0", $s);
  }
  return $s;
}

// Remove invalid XML Characters
function stripInvalidXml($value) {
  $ret = "";
  $current;
  if (empty($value)) {
    return $ret;
  }

  $length = strlen($value);
  for ($i = 0; $i < $length; $i++) {
    $current = ord($value{$i});
    if (($current == 0x9) ||
            ($current == 0xA) ||
            ($current == 0xD) ||
            (($current >= 0x20) && ($current <= 0xD7FF)) ||
            (($current >= 0xE000) && ($current <= 0xFFFD)) ||
            (($current >= 0x10000) && ($current <= 0x10FFFF))) {
      $ret .= chr($current);
    } else {
      $ret .= " ";
    }
  }
  return $ret;
}

// Convert a string to proper UTF-8
function convertToUTF8($s) {
  if (!mb_check_encoding($s, 'UTF-8') || !($s === mb_convert_encoding(mb_convert_encoding($s, 'UTF-32', 'UTF-8'), 'UTF-8', 'UTF-32'))) {
    $s = mb_convert_encoding($s, 'UTF-8');
  }
  return $s;
}

// Convert a string to UTF-8 and encode the special characters
function my_encode($s) {
// Convert to UTF-8
  $s = convertToUTF8($s);

// Strip all HTML Tags
  $s = strip_tags($s);

// Encrypt the data
  $s = my_encrypt($s);

// Convert entities like &uuml; to ü
  if ((version_compare(phpversion(), '5.0') < 0)) {
    $s = html_entity_decode($s);
  } else {
    $s = html_entity_decode($s, ENT_COMPAT, 'UTF-8');
  }

// Replace special characters
  $s = htmlspecialchars($s, ENT_COMPAT, 'UTF-8');

// Remove invalid characters
  $s = stripInvalidXml($s);
  return $s;
}

// add CDATA section
function add_CDATA($cdataValue) {

  $cdataValue = trim($cdataValue);
  return (strlen($cdataValue) < 1 ? "" : "<![CDATA[". $cdataValue ."]]>");
}

// Convert date to ISO8601
function date_to_ISO($datestring) {
  return date('c', strtotime($datestring));
}

// Exit with error message
function exit_with_error($err) {
  echo (" <error>" . $err . "</error>\n");
  echo ("</webshopexport>\n");
  exit();
}

// Keep the BR-tags
function my_clean_nl($s) {
// Keep the BR-tags
//$s = str_replace("\n", "<br />", $s);
// remove the carriage return 
  $s = str_replace("\r", "", $s);
// remove non breakable spaces return 
  $s = str_replace("\xC2\xA0", " ", $s);
  $s = trim($s);
  return $s;
}

// get default language 
$lang_query = xtc_db_query("SELECT languages_id,
                                   code
                              FROM languages
                             WHERE sort_order = 1
                             LIMIT 1
                           ");
if (xtc_db_num_rows($lang_query) == 1) {
  $lang = xtc_db_fetch_array($lang_query);
  define('DEFAULT_LANGUAGE_CODE', $lang['code']);
  define('DEFAULT_LANGUAGE_ID', $lang['languages_id']);
} else {
  exit_with_error('Language ' . DEFAULT_LANGUAGE . ' not found');
}

class order {

  var $info, $totals, $products, $customer, $delivery;

  function __construct($order_id) {
    $this->info = array();
    $this->totals = array();
    $this->products = array();
    $this->customer = array();
    $this->delivery = array();

    $this->query($order_id);
  }

  function query($order_id) {
    $order_query = xtc_db_query("SELECT customers_id,
                                        customers_cid,
                                        customers_name,
                                        customers_company,
                                        customers_street_address,
                                        customers_suburb,
                                        customers_city,
                                        customers_postcode,
                                        customers_state,
                                        customers_country,
                                        customers_telephone,
                                        customers_email_address,
                                        customers_address_format_id,
                                        delivery_name,
                                        delivery_company,
                                        delivery_street_address,
                                        delivery_suburb,
                                        delivery_city,
                                        delivery_postcode,
                                        delivery_state,
                                        delivery_country
                                        delivery_address_format_id,
                                        billing_name,
                                        billing_company,
                                        billing_street_address,
                                        billing_suburb,
                                        billing_city,
                                        billing_postcode,
                                        billing_state,
                                        billing_country,
                                        billing_address_format_id,
                                        payment_method,
                                        currency,
                                        currency_value,
                                        date_purchased,
                                        orders_status,
                                        last_modified,
                                        language
                                   FROM orders
                                  WHERE orders_id = '" . (int) $order_id . "'
                                ");
    $order = xtc_db_fetch_array($order_query);

    $totals_query = xtc_db_query("SELECT title,
                                         text
                                    FROM orders_total
                                   WHERE orders_id = '" . (int) $order_id . "'
                                ORDER BY sort_order
                                 ");

    while ($totals = xtc_db_fetch_array($totals_query)) {
      $this->totals[] = array(
          'title' => $totals['title'],
          'text' => $totals['text'],
      );
    }

    $this->info = array(
        'currency' => $order['currency'],
        'currency_value' => $order['currency_value'],
        'payment_method' => $order['payment_method'],
        'payment_class' => $order['payment_class'],
        'date_purchased' => $order['date_purchased'],
        'orders_status' => $order['orders_status'],
        'language' => $order['language'],
        'last_modified' => $order['last_modified'],
    );

    $this->customer = array(
        'id' => $order['customers_id'],
        'cid' => $order['customers_cid'],
        'firstname' => "",
        'lastname' => $order['customers_name'],
        'name' => $order['customers_name'],
        'company' => $order['customers_company'],
        'street_address' => $order['customers_street_address'],
        'suburb' => $order['customers_suburb'],
        'city' => $order['customers_city'],
        'postcode' => $order['customers_postcode'],
        'state' => $order['customers_state'],
        'country' => $order['customers_country'],
        'format_id' => $order['customers_address_format_id'],
        'telephone' => $order['customers_telephone'],
        'email_address' => $order['customers_email_address'],
    );

    $this->delivery = array(
        'name' => $order['delivery_name'],
        'firstname' => "",
        'lastname' => $order['delivery_name'],
        'gender' => "",
        'company' => $order['delivery_company'],
        'street_address' => $order['delivery_street_address'],
        'suburb' => $order['delivery_suburb'],
        'city' => $order['delivery_city'],
        'postcode' => $order['delivery_postcode'],
        'state' => $order['delivery_state'],
        'country' => $order['delivery_country'],
        'format_id' => $order['delivery_address_format_id'],
    );

    $this->billing = array(
        'name' => $order['billing_name'],
        'firstname' => "",
        'lastname' => $order['billing_name'],
        'gender' => "",
        'company' => $order['billing_company'],
        'street_address' => $order['billing_street_address'],
        'suburb' => $order['billing_suburb'],
        'city' => $order['billing_city'],
        'postcode' => $order['billing_postcode'],
        'state' => $order['billing_state'],
        'country' => $order['billing_country'],
        'format_id' => $order['billing_address_format_id'],
    );

    $customers_id = $this->customer['id']; // TODO why?
    $firstandlastname = $this->customer['firstname'] . " " . $this->customer['lastname'] . "-";

    $orders_address_query = xtc_db_query("SELECT customers_id,
                                                 entry_gender,
                                                 entry_firstname,
                                                 entry_lastname,
                                                 entry_country_id,
                                                 entry_zone_id
                                            FROM address_book
                                           WHERE customers_id = '" . (int) $customers_id . "'
                                         ");

    while ($orders_address = xtc_db_fetch_array($orders_address_query)) {
      $firstandlastname = $orders_address['entry_firstname'] . " " . $orders_address['entry_lastname'];

      $customer_entry_country_id = $orders_address['entry_country_id'];
      $customer_entry_zone_id = $orders_address['entry_zone_id'];

      if ($firstandlastname == $this->billing['name']) {
        $this->billing['firstname'] = $orders_address['entry_firstname'];
        $this->billing['lastname'] = $orders_address['entry_lastname'];
        $this->billing['gender'] = $orders_address['entry_gender'];
      }
      if ($firstandlastname == $this->delivery['name']) {
        $this->delivery['firstname'] = $orders_address['entry_firstname'];
        $this->delivery['lastname'] = $orders_address['entry_lastname'];
        $this->delivery['gender'] = $orders_address['entry_gender'];
      }
    }


//start with a default value
    $customer_geo_zone = 1;

// Get the geozone if only the country matches
    $geo_zone_query = xtc_db_query("SELECT geo_zone_id,
                                           zone_country_id,
                                           zone_id 
                                      FROM zones_to_geo_zones
                                     WHERE zone_country_id = '" . (int) $customer_entry_country_id . "'
                                   ");
    while ($geo_zone_line = xtc_db_fetch_array($geo_zone_query)) {
      if ($geo_zone_line['geo_zone_id'] > 0) {
        $customer_geo_zone = $geo_zone_line['geo_zone_id'];
      }
    }

// Get the geozone if only the country and the zone matches
    $geo_zone_query = xtc_db_query("SELECT geo_zone_id,
                                           zone_country_id,
                                           zone_id 
                                      FROM zones_to_geo_zones
                                     WHERE ((zone_country_id = '" . (int) $customer_entry_country_id . "') AND (zone_id = '" . (int) $customer_entry_zone_id . "'))
                                   ");
    while ($geo_zone_line = xtc_db_fetch_array($geo_zone_query)) {
      if ($geo_zone_line['geo_zone_id'] > 0) {
        $customer_geo_zone = $geo_zone_line['geo_zone_id'];
      }
    }

    $index = 0;

    $orders_products_query = xtc_db_query("SELECT tax.tax_description,
                                                  ordprod.orders_products_id,
                                                  ordprod.products_name,
                                                  ordprod.products_id,
                                                  ordprod.products_model,
                                                  ordprod.products_price,
                                                  ordprod.products_tax,
                                                  ordprod.products_quantity,
                                                  ordprod.final_price,
                                                  ordprod.products_ean,
                                                  p_vpe.products_vpe_name
                                             FROM orders_products ordprod
                                        LEFT JOIN products prod ON (prod.products_id = ordprod.products_id) 
                                        LEFT JOIN tax_rates tax ON ((prod.products_tax_class_id = tax.tax_class_id) AND (tax.tax_zone_id = '" . (int) $customer_geo_zone . "'))
                                        LEFT JOIN languages langu ON (langu.languages_id = '" . DEFAULT_LANGUAGE_ID . "')
                                        LEFT JOIN products_vpe p_vpe ON (prod.products_vpe = p_vpe.products_vpe_id) AND (p_vpe.language_id = langu.languages_id)
                                            WHERE ordprod.orders_id = '" . (int) $order_id . "' 
                                          ");
    while ($orders_products = xtc_db_fetch_array($orders_products_query)) {
      $this->products[$index] = array(
          'id' => $orders_products['orders_products_id'],
          'qty' => $orders_products['products_quantity'],
          'name' => $orders_products['products_name'],
          'products_id' => $orders_products['products_id'],
          'ean' => $orders_products['products_ean'],
          'model' => $orders_products['products_model'],
          'tax' => $orders_products['products_tax'],
          'tax_description' => $orders_products['tax_description'],
          'price' => $orders_products['products_price'],
          'products_vpe_name' => $orders_products['products_vpe_name'],
          'final_price' => $orders_products['final_price'],
      );

      $category_query = xtc_db_query("SELECT cat_desc.categories_name,
                                             langu.code,
                                             cat_desc.categories_id,
                                             prod_cat.products_id
                                        FROM categories_description cat_desc
                                   LEFT JOIN products_to_categories prod_cat ON (prod_cat.categories_id = cat_desc.categories_id)
                                   LEFT JOIN languages langu ON (langu.languages_id = cat_desc.language_id)
                                       WHERE prod_cat.products_id = '" . (int) $orders_products['products_id'] . "'
                                         AND langu.languages_id ='" . DEFAULT_LANGUAGE_ID . "' 
                                     ");
      $category = "";
      if ($orders_category = xtc_db_fetch_array($category_query)) {
        $category = $orders_category['categories_name'];
      }
      $this->products[$index]['category'] = $category;

      $subindex = 0;
      $attributes_query = xtc_db_query("SELECT products_options,
                                               products_options_values,
                                               options_values_price,
                                               price_prefix
                                          FROM orders_products_attributes
                                         WHERE orders_id = '" . (int) $order_id . "' 
                                           AND orders_products_id = '" . (int) $orders_products['orders_products_id'] . "'
                                       ");
      if (xtc_db_num_rows($attributes_query)) {
        while ($attributes = xtc_db_fetch_array($attributes_query)) {
          $this->products[$index]['attributes'][$subindex] = array(
              'option' => $attributes['products_options'],
              'value' => $attributes['products_options_values'],
              'prefix' => $attributes['price_prefix'],
              'price' => $attributes['options_values_price'],
          );
          $subindex++;
        }
      }
      $index++;
    }
  }

}

// load the installed payment module
if (defined('MODULE_PAYMENT_INSTALLED') && xtc_not_null(MODULE_PAYMENT_INSTALLED)) {
  $modules_payment = explode(';', MODULE_PAYMENT_INSTALLED);

  $include_modules_payment = array();

  if ((xtc_not_null($module)) && (in_array($module . '.' . substr($PHP_SELF, (strrpos($PHP_SELF, '.') + 1)), $modules_payment))) {
    $selected_module = $module;

    $include_modules_payment[] = array(
        'class' => $module,
        'file' => $module . '.php',
    );
  } else {
    reset($modules_payment);
    while (list(, $value) = each($modules_payment)) {
      $class = substr($value, 0, strrpos($value, '.'));
      $include_modules_payment[] = array(
          'class' => $class,
          'file' => $value,
      );
    }
  }
}


// load the installed shipping module
if (defined('MODULE_SHIPPING_INSTALLED') && xtc_not_null(MODULE_SHIPPING_INSTALLED)) {
  $modules_shipping = explode(';', MODULE_SHIPPING_INSTALLED);

  $include_modules_shipping = array();

  if ((xtc_not_null($module)) && (in_array($module . '.' . substr($PHP_SELF, (strrpos($PHP_SELF, '.') + 1)), $modules_shipping))) {
    $selected_module = $module;

    $include_modules_shipping[] = array(
        'class' => $module,
        'file' => $module . '.php'
    );
  } else {
    reset($modules_shipping);
    while (list(, $value) = each($modules_shipping)) {
      $class = substr($value, 0, strrpos($value, '.'));
      $include_modules_shipping[] = array(
          'class' => $class,
          'file' => $value,
      );
    }
  }
}



// search all languages for the payment method
$languages_query = xtc_db_query("SELECT directory
                                   FROM languages
                                ");
while ($languages = xtc_db_fetch_array($languages_query)) {
  for ($i = 0, $n = sizeof($include_modules_payment); $i < $n; $i++) {
    $filename = LANG_DIR . $languages[directory] . '/modules/payment/' . $include_modules_payment[$i]['file'];
    if (file_exists($filename)) {
      $paymentfile = fopen($filename, 'r');
      while (!feof($paymentfile)) {
        $zeile = fgets($paymentfile, 1024);
        $pos1 = strpos($zeile, "('MODULE_PAYMENT_");
        $pos2 = strpos($zeile, "_TEXT_TITLE'");
        if (($pos1 > 0) && ($pos2 > 0)) {
          $paymenttext = substr($zeile, $pos2 + 13);
          $paymenttext = substr($paymenttext, strpos($paymenttext, "'") + 1);
          $paymenttext = substr($paymenttext, 0, strrpos($paymenttext, "'"));
          $paymenttext = trim($paymenttext);
          if ($paymenttext) {
            $paymentsynonym[$include_modules_payment[$i]['class']] = $paymenttext;
          }
        }
      }
      fclose($paymentfile);
    }
  }
}

// search all shippings for the shipping method
$languages_query = xtc_db_query("SELECT directory
                                   FROM languages
                                ");
while ($languages = xtc_db_fetch_array($languages_query)) {
  for ($i = 0, $n = sizeof($include_modules_shipping); $i < $n; $i++) {
    $filename = LANG_DIR . $languages[directory] . '/modules/shipping/' . $include_modules_shipping[$i]['file'];
    if (file_exists($filename)) {
      $shippingfile = fopen($filename, 'r');
      while (!feof($shippingfile)) {
        $zeile = fgets($shippingfile, 1024);
        $pos1 = strpos($zeile, "('MODULE_SHIPPING_");
        $pos2 = strpos($zeile, "_TEXT_TITLE'");
        if (($pos1 > 0) && ($pos2 > 0)) {
          $shippingtext = substr($zeile, $pos2 + 13);
          $shippingtext = substr($shippingtext, strpos($shippingtext, "'") + 1);
          $shippingtext = substr($shippingtext, 0, strrpos($shippingtext, "'"));
          $shippingtext = trim($shippingtext);
          if ($shippingtext) {
            $shippingssynonym[$shippingtext] = $include_modules_shipping[$i]['class'];
          }
        }
      }
      fclose($shippingfile);
    }
  }
}

// parse POST parameters
require (DIR_FS_CATALOG . DIR_WS_CLASSES . 'inputfilter.php');
$inputfilter = new Inputfilter();
$_POST = $inputfilter->validate($_POST);

$post_action = (isset($_POST['action']) ? $_POST['action'] : '');
$post_orderstosync = (isset($_POST['setstate']) ? $_POST['setstate'] : '{}');
$post_maxproducts = (isset($_POST['maxproducts']) ? $_POST['maxproducts'] : '');
$post_lasttime_iso = (isset($_POST['lasttime']) ? $_POST['lasttime'] : '');
// convert ISO date from Fakturama to datetime for database
$lasttime = date("Y-m-d H:i:s", strtotime((int) $post_lasttime_iso));

//////////////////////////////////////////////////////
#file_put_contents("log.txt", print_r($_POST, true));
//////////////////////////////////////////////////////
$post_orderstosync = substr($post_orderstosync, 0, -1);
$post_orderstosync = substr($post_orderstosync, 1);
$post_orderstosync = explode(",", $post_orderstosync);

$username = xtc_db_prepare_input($_POST['username']);
$password = xtc_db_prepare_input($_POST['password']);

// does action start with "get" ?
if (strncmp($post_action, "get", 3) == 0) {
// does the action contains one of the following keys:
  $post_action_getproducts = strpos($post_action, "products");
  $post_action_getorders = strpos($post_action, "orders");
  $post_action_getcontacts = strpos($post_action, "contacts");
  $post_action_getstatusvalues = strpos($post_action, "status");
}

// TODO
$post_action_getproducts = true;
$post_action_getorders = true;


if (stripos($_POST['action'], 'status') !== FALSE) {
  require('includes/version.php');
  $orders_statuses = array();
  $orders_status_array = array();
  $orders_status_query = xtc_db_query("SELECT orders_status_id,
                                              orders_status_name
                                         FROM orders_status
                                        WHERE language_id = '" . DEFAULT_LANGUAGE_ID . "'
                                      ");
  while ($orders_status = xtc_db_fetch_array($orders_status_query)) {
    $orders_statuses[] = array(
        'id' => $orders_status['orders_status_id'],
        'text' => $orders_status['orders_status_name'],
    );
    $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
  }

// start xml output
  echo '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<webshopexport version="2.0" xmlns="http://www.fakturama.org">
    <webshop shop="modified Shop" url="' . my_encrypt(HTTP_CATALOG_SERVER) . '/"/>' . PHP_EOL;
  echo '<complete_version>' . PROJECT_VERSION . '</complete_version>' . PHP_EOL;
  echo ' <status_list>' . PHP_EOL;

  foreach ($orders_status_array as $id => $status_name) {
    echo '  <status id="' . $id . '" name="' . $status_name . '"></status>' . PHP_EOL;
  }

  echo ' </status_list>' . PHP_EOL;
  echo '</webshopexport>' . PHP_EOL;

  exit;
}

// generate header of response
echo '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL;
echo '<webshopexport version="' . FAKTURAMA_CONNECTOR_VERSION . '" xmlns="http://www.fakturama.org">' . PHP_EOL;

echo '<phpversion>';
echo phpversion();
echo '</phpversion>' . PHP_EOL;
echo '<webshop shop="modifiedShop" ';
echo 'url="' . my_encrypt(HTTP_CATALOG_SERVER) . '/"';
echo '></webshop>' . PHP_EOL;

if (!defined('DEFAULT_LANGUAGE_ID')) {
  exit_with_error('DEFAULT_LANGUAGE_ID not defined');
}

// TODO optional create entry in admin_access and check for rights there
$admin_valid = 0;
$admin_query = xtc_db_query("SELECT customers_id,
                                    customers_password
                               FROM customers
                              WHERE customers_email_address = '" . $username . "'
                                AND customers_status = 0
                            ");
// At least one admin was found
if (xtc_db_num_rows($admin_query) > 0) {
  $admin = xtc_db_fetch_array($admin_query);
  // list of project database tables
  require('../' . DIR_WS_INCLUDES . 'database_tables.php');
  require_once(DIR_FS_INC . 'xtc_validate_password.inc.php');
  if (xtc_validate_password($password, $admin['customers_password'], $admin['customers_id'])) {
    $admin_valid = 1;
  }
}

// No admin with valid password found
if ($admin_valid != 1) {
  exit_with_error('Invalid username or password');
}

// update the shop values
foreach ($post_orderstosync as $ordertosync) {
  list($orders_id_tosync, $orders_status_tosync) = explode("=", trim($ordertosync));
  if ($orders_status_tosync == 'pending') {
    $orders_status_tosync = 1;
  }

  if ($orders_status_tosync == 'processing') {
    $orders_status_tosync = 2;
  }

  if ($orders_status_tosync == 'shipped') {
    $orders_status_tosync = 3;
  }

  $customer_notified = 0;

// Notify the customer
  $notify_comments = '';
// Is there a comment ?
  if (strlen($orders_status_tosync) > 1) {
    $notify_comments = substr($orders_status_tosync, 1);
  }

// First character is the new status
  $orders_status_tosync = substr($orders_status_tosync, 0, 1);

  if (startsWith($notify_comments, "*")) {
// Remove the "*"
    $notify_comments = substr($notify_comments, 1);

// Replace the &comma;
    $notify_comments = str_replace('&comma;', ",", $notify_comments);

// Replace the &equal;
    $notify_comments = str_replace('&equal;', "=", $notify_comments);

// Convert it into the correct character encoding
    $notify_comments = iconv("UTF-8", FAKTURAMA_WEBSHOP_CHARSET . "//TRANSLIT", $notify_comments);

    $notify_comments_mail = $notify_comments;

    $order = new order($orders_id_tosync);

    $lang_query = xtc_db_query("SELECT languages_id
                                  FROM languages
                                 WHERE directory = '" . $order->info['language'] . "'
                               ");
    $lang = xtc_db_fetch_array($lang_query);
    $lang = $lang['languages_id'];
    if (!isset($lang)) {
      $lang = DEFAULT_LANGUAGE_ID;
    }

    $orders_statuses = array();
    $orders_status_array = array();
    $orders_status_query = xtc_db_query("SELECT orders_status_id,
                                                orders_status_name
                                           FROM orders_status
                                          WHERE language_id = '" . $lang . "'
                                        ");
    while ($orders_status = xtc_db_fetch_array($orders_status_query)) {
      $orders_statuses[] = array(
          'id' => $orders_status['orders_status_id'],
          'text' => $orders_status['orders_status_name'],
      );
      $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
    }

    $email_valid = 0;
    if (!empty($order->customer['email_address'])) {
      $email_valid = 1;
    }

    $smarty = new Smarty;
// assign language to template for caching
    $smarty->assign('language', $order->info['language']);
    $smarty->caching = false;

// set dirs manual
    $smarty->template_dir = DIR_FS_CATALOG . 'templates';
    $smarty->compile_dir = DIR_FS_CATALOG . 'templates_c';
    $smarty->config_dir = DIR_FS_CATALOG . 'lang';

    $smarty->assign('tpl_path', 'templates/' . CURRENT_TEMPLATE . '/');
    $smarty->assign('logo_path', HTTP_SERVER . DIR_WS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/img/');

    $smarty->assign('NAME', $order->customer['name']);
    $smarty->assign('ORDER_NR', $orders_id_tosync);
    $smarty->assign('ORDER_LINK', xtc_catalog_href_link("account_history_info.php", 'order_id=' . $orders_id_tosync, 'SSL'));
    $smarty->assign('ORDER_DATE', xtc_date_long($order->info['date_purchased']));
    $smarty->assign('NOTIFY_COMMENTS', nl2br($notify_comments_mail));
    $smarty->assign('ORDER_STATUS', $orders_status_array[$orders_status_tosync]);

    $html_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $order->info['language'] . '/change_order_mail.html');
    $txt_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $order->info['language'] . '/change_order_mail.txt');

    if ($email_valid) {
      $email_send_status = sbf_php_mail(EMAIL_BILLING_ADDRESS, EMAIL_BILLING_NAME, $order->customer['email_address'], $order->customer['name'], '', EMAIL_BILLING_REPLY_ADDRESS, EMAIL_BILLING_REPLY_ADDRESS_NAME, '', '', EMAIL_BILLING_SUBJECT, $html_mail, $txt_mail, $order->info['language']);
      if (empty($email_send_status)) {
        $customer_notified = 1;
      } else {
        echo (" <error>" . $email_send_status . "</error>\n");
      }
    }
  }

  if (($orders_id_tosync > 0) && ($orders_status_tosync >= 1) && ($orders_status_tosync <= 3)) {
    xtc_db_query("UPDATE orders
                     SET orders_status = '" . $orders_status_tosync . "'
                   WHERE orders_id = '" . (int) $orders_id_tosync . "'
                 ");
    xtc_db_query("INSERT INTO orders_status_history (orders_id,
                                                     orders_status_id,
                                                     date_added,
                                                     customer_notified, comments)
                                             VALUES ('" . (int) $orders_id_tosync . "',
                                                     '" . $orders_status_tosync . "',
                                                     now(),
                                                     '" . $customer_notified . "',
                                                     '" . $notify_comments . "')
                 ");
  }
}

// generate list of all products
if ($post_action_getproducts) {
  $imagepath = DIR_WS_IMAGES .'product_images/info_images/';
  $fs_imagepath = DIR_FS_CATALOG_INFO_IMAGES;

  echo ' <products imagepath="' . my_encrypt($imagepath) . '">' . PHP_EOL;

  // Only modified/new products since $lasttime
  $lasttime_query = "";
  if ($lasttime > 0) {
    $lasttime_query = " AND (prod.products_last_modified > '" . $lasttime . "' ";
    $lasttime_query .= " OR prod.products_last_modified IS NULL) ";
  }
  
  // Limit the query to $post_maxproducts
  $productslimit_query = "";
  if ($post_maxproducts > 0) {
    $productslimit_query = " LIMIT " . (int) $post_maxproducts;
  }

  $products_query = xtc_db_query("SELECT prod_desc.products_name,
                                         prod_desc.products_description,
                                         prod_desc.products_short_description,
                                         prod.products_model,
                                         prod.products_image,
                                         products_quantity,
                                         prod.products_id,
                                         prod.products_ean,
                                         prod.products_price, 
                                         prod.products_price,
                                         cat_desc.categories_name,
                                         countries.countries_id,
                                         tax.tax_rate,
                                         tax.tax_description,
                                         p_vpe.products_vpe_name
                                    FROM products_description prod_desc   
                               LEFT JOIN products prod ON (prod.products_id = prod_desc.products_id) 
                               LEFT JOIN languages langu ON (langu.languages_id = prod_desc.language_id) 
                               LEFT JOIN products_to_categories prod_cat ON (prod_cat.products_id = prod.products_id)
                               LEFT JOIN categories_description cat_desc ON (prod_cat.categories_id = cat_desc.categories_id) AND  (cat_desc.language_id  = langu.languages_id )
                               LEFT JOIN countries ON  (countries.countries_id = '" . STORE_COUNTRY . "')
                               LEFT JOIN zones_to_geo_zones z2geozones ON (countries.countries_id = z2geozones.zone_country_id)
                               LEFT JOIN tax_rates tax ON (prod.products_tax_class_id = tax.tax_class_id) AND (z2geozones.geo_zone_id = tax.tax_zone_id)
                               LEFT JOIN products_vpe p_vpe ON (prod.products_vpe = p_vpe.products_vpe_id) AND (p_vpe.language_id = langu.languages_id)         
                                   WHERE langu.languages_id = '" . DEFAULT_LANGUAGE_ID . "'
                                     AND prod.products_status = '1'
                                                           
                                 ");
  $last_products_model_name = "";
  while ($products = xtc_db_fetch_array($products_query)) {
    $products_model_name = $products['products_model'] . $products['products_name'];
    if ($last_products_model_name != $products_model_name) {
      echo '  <product ';
      echo 'gross="' . my_encrypt(number_format($products['products_price'] * (1 + $products['tax_rate'] / 100), 2, '.', '')) . '" ';
      echo 'vatpercent="' . my_encrypt(number_format($products['tax_rate'], 2)) . '" ';
      echo 'quantity="' . my_encrypt($products['products_quantity']) . '" ';
      echo 'id="' . my_encrypt($products['products_id']) . '" ';
      echo '>' . PHP_EOL;
      echo '   <model>' . add_CDATA(my_encode($products['products_model'])) . '</model>' . PHP_EOL;
      echo '   <ean>' . add_CDATA(my_encode($products['products_ean'])) . '</ean>' . PHP_EOL;
      echo '   <name>' . add_CDATA(my_encode($products['products_name'])) . '</name>' . PHP_EOL;

#################
## CATEGORIES PATH ##
################
      if ($products['parent_id'] > 0) {
        $parentindex = $products['parent_id'];
        $parent_cat = array();
        while ($parentindex > 0) {
          $query_get_parent_categories = xtc_db_query("SELECT cat_desc.categories_name AS parent_cat,
                                                              cat.parent_id AS p_id 
                                                         FROM categories_description cat_desc 
                                                   INNER JOIN categories cat ON (cat_desc.categories_id = cat.categories_id) 
                                                    LEFT JOIN languages langu ON (langu.languages_id = cat_desc.language_id) 
                                                        WHERE cat_desc.categories_id = " . $parentindex . " 
                                                          AND langu.languages_id = '" . DEFAULT_LANGUAGE_ID . "'
                                                       ");
          if ($parent_categories = xtc_db_fetch_array($query_get_parent_categories)) {
            $parent_cat[] = $parent_categories['parent_cat'];
          }
          $parentindex = $parent_categories['p_id'];
        }

// bring it in the right order
        $parent_cat = array_reverse($parent_cat);
// build a path from the found categories
        $cat_path = implode("/", $parent_cat) . "/";

        echo '   <category>' . add_CDATA(my_encode($cat_path . $products['categories_name'])) . '</category>' . PHP_EOL;
      } else {
        echo '   <category>' . add_CDATA(my_encode($products['categories_name'])) . '</category>' . PHP_EOL;
      }

      echo '   <qunit>' . my_encode($products['products_vpe_name']) . '</qunit>' . PHP_EOL;
      echo '   <vatname>' . my_encode($products['tax_description']) . '</vatname>' . PHP_EOL;
      echo '   <short_description>' . add_CDATA(my_clean_nl(my_encode($products['products_short_description']))) . '</short_description>' . PHP_EOL;

// Use the image only, if it exists 
      if (file_exists($fs_imagepath . $products['products_image'])) {
        echo '   <image>' . my_encrypt($products['products_image']) . '</image>' . PHP_EOL;
      }
      echo ' </product>' . PHP_EOL . PHP_EOL;
    }

    $last_products_model_name = $products_model_name;
  }
}
echo ' </products>' . PHP_EOL . PHP_EOL . PHP_EOL . PHP_EOL;


echo ' <orders>' . PHP_EOL;

// generate list of all orders
if ($post_action_getorders) {
  $check_orders_query = xtc_db_query("SELECT o.orders_id,
                                             o.orders_status,
                                             ot.text AS order_total
                                        FROM orders o
                                   LEFT JOIN orders_total ot ON(o.orders_id = ot.orders_id)
                                       WHERE ot.class = 'ot_total'
                                         AND o.orders_status = '1'
                                    ORDER BY o.orders_id DESC
                                     ");
  while ($check_orders = xtc_db_fetch_array($check_orders_query)) {
    $oID = $check_orders['orders_id'];
    $order = new order($oID);

    $payment_class = $order->info['payment_class'];
    $order->info['payment_method'] = $paymentsynonym[$order->info['payment_class']];

    $payment_text = $payment_class;

    if ($payment_class == 'cod') {
      $payment_text = 'cod';
    } else if ($payment_class == 'moneyorder') {
      $payment_text = 'prepayment';
    } else if ($payment_class == 'cc') {
      $payment_text = 'creditcard';
    } else if ($payment_class == 'authorizenet_cc_aim') {
      $payment_text = 'creditcard';
    } else if ($payment_class == 'authorizenet_cc_sim') {
      $payment_text = 'creditcard';
    } else if ($payment_class == 'chronopay') {
      $payment_text = 'chronopay.com';
    } else if ($payment_class == 'ipayment_cc') {
      $payment_text = 'ipayment.de';
    } else if ($payment_class == 'nochex') {
      $payment_text = 'nochex.com';
    } else if ($payment_class == 'paypal_direct') {
      $payment_text = 'paypal.com';
    } else if ($payment_class == 'paypal_express') {
      $payment_text = 'paypal.com';
    } else if ($payment_class == 'paypal_standard') {
      $payment_text = 'paypal.com';
    } else if ($payment_class == 'paypal_uk_direct') {
      $payment_text = 'paypal.com';
    } else if ($payment_class == 'paypal_uk_express') {
      $payment_text = 'paypal.com';
    } else if ($payment_class == 'paypalplus') {
      $payment_text = 'paypalplus';
    } else if ($payment_class == 'pm2checkout') {
      $payment_text = '2checkout.com';
    } else if ($payment_class == 'psigate') {
      $payment_text = 'psigate.com';
    } else if ($payment_class == 'secpay') {
      $payment_text = 'secpay.com';
    } else if ($payment_class == 'sofortueberweisung_direct') {
      $payment_text = 'payment-networt.com';
    } else if ($payment_class == 'worldpay_junior') {
      $payment_text = 'bsworldpay.com';
    }

    $orders_history_query = xtc_db_query("SELECT orders_status_id,
                                                 date_added,
                                                 comments
                                            FROM orders_status_history
                                           WHERE orders_id = '" . (int) $oID . "'
                                        ORDER BY date_added
                                         ");

// if entry is empty, use entry from customers data or from delivery data
    if (empty($order->billing['telephone']) && !empty($order->customer['telephone'])) {
      $order->billing['telephone'] = $order->customer['telephone'];
    }

    if (empty($order->billing['telephone']) && !empty($order->delivery['telephone'])) {
      $order->billing['telephone'] = $order->delivery['telephone'];
    }

// if entry is empty, use entry from customers data or from delivery data
    if (empty($order->billing['email_address']) && !empty($order->customer['email_address'])) {
      $order->billing['email_address'] = $order->customer['email_address'];
    }

    if (empty($order->billing['email_address']) && !empty($order->delivery['email_address'])) {
      $order->billing['email_address'] = $order->delivery['email_address'];
    }

    echo ' <order id = "' . my_encrypt($oID) . '" date="' . my_encrypt(date_to_ISO($order->info['date_purchased'])) . '" ';

    if ($order->info['orders_status'] == 1) {
      $order_status_text = "pending";
    } else if ($order->info['orders_status'] == 2) {
      $order_status_text = "processing";
    } else if ($order->info['orders_status'] == 3) {
      $order_status_text = "shipped";
    }

    $total = 0.0;
    $replace_dot = array("." => "", "," => ".");
    if (preg_match("/[0-9]+\.[0-9]+/", strtr(strip_tags($check_orders['order_total']), $replace_dot), $matches)) {
      $total = $matches[0];
    }

    echo 'currency="' . $order->info['currency'] . '" ';
    echo 'currency_value="' . $order->info['currency_value'] . '" ';
    echo 'status="' . my_encode($order_status_text) . '" ';
    echo '>' . PHP_EOL;
    echo '   <contact ';
    echo 'id="' . my_encode($order->customer['cid']) . '">' . PHP_EOL;
    echo '    <gender>' . my_encode($order->billing['gender']) . '</gender>' . PHP_EOL;
    echo '    <firstname>' . my_encode($order->billing['firstname']) . '</firstname>' . PHP_EOL;
    echo '    <lastname>' . my_encode($order->billing['lastname']) . '</lastname>' . PHP_EOL;
    echo '    <company>' . my_encode($order->billing['company']) . '</company>' . PHP_EOL;
    echo '    <street>' . my_encode($order->billing['street_address']) . '</street>' . PHP_EOL;
    echo '    <zip>' . my_encode($order->billing['postcode']) . '</zip>' . PHP_EOL;
    echo '    <city>' . my_encode($order->billing['city']) . '</city>' . PHP_EOL;
    echo '    <country>' . my_encode($order->billing['country']) . '</country>' . PHP_EOL;
    echo '    <delivery_gender>' . my_encode($order->delivery['gender']) . '</delivery_gender>' . PHP_EOL;
    echo '    <delivery_firstname>' . my_encode($order->delivery['firstname']) . '</delivery_firstname>' . PHP_EOL;
    echo '    <delivery_lastname>' . my_encode($order->delivery['lastname']) . '</delivery_lastname>' . PHP_EOL;
    echo '    <delivery_company>' . my_encode($order->delivery['company']) . '</delivery_company>' . PHP_EOL;
    echo '    <delivery_street>' . my_encode($order->delivery['street_address']) . '</delivery_street>' . PHP_EOL;
    echo '    <delivery_zip>' . my_encode($order->delivery['postcode']) . '</delivery_zip>' . PHP_EOL;
    echo '    <delivery_city>' . my_encode($order->delivery['city']) . '</delivery_city>' . PHP_EOL;
    echo '    <delivery_country>' . my_encode($order->delivery['country']) . '</delivery_country>' . PHP_EOL;
    echo '    <phone>' . my_encode($order->billing['telephone']) . '</phone>' . PHP_EOL;
    echo '    <email>' . my_encode($order->billing['email_address']) . '</email>' . PHP_EOL;
    echo '   </contact>' . PHP_EOL;

    while ($orders_history = xtc_db_fetch_array($orders_history_query)) {
      if (strlen(trim($orders_history['comments']))) {
        //  add a CDATA section in case of special signs in comment like < or >
        $comment = '<![CDATA[' . xtc_db_output($orders_history['comments']) . ']]>';
        echo '    <comment date="' . date_to_ISO($orders_history['date_added']) . '">';
        echo my_encode(nl2br($comment));
        echo '</comment>' . PHP_EOL;
      }
    }

    foreach ($order->products as $product) {
      $orders_tax_query = xtc_db_query("SELECT tax_rate,
                                               tax_description
                                          FROM tax_rates
                                         WHERE tax_class_id = '" . $tax_class . "'
                                       ");
      if ($taxs = xtc_db_fetch_array($orders_tax_query)) {
        $shipping_tax = $taxs['tax_rate'];
        $shipping_tax_name = $taxs['tax_description'];
      }

      echo '   <item ';
      echo 'productid="' . my_encode($product['products_id']) . '" ';
      echo 'quantity="' . my_encrypt($product['qty']) . '" ';
      echo 'gross="' . my_encrypt(number_format($product['price'], 2, '.', '')) . '" ';
      echo 'vatpercent="' . my_encrypt(number_format($product['tax'], 2)) . '">' . PHP_EOL;

      echo '    <model>';
      if (!empty($product['model'])) {
        echo (my_encode($product['model']));
      } else {
        echo (my_encode($product['name']));
      }
      echo '</model>' . PHP_EOL;
      echo '    <ean>' . my_encode($product['ean']) . '</ean>' . PHP_EOL;
      echo '    <name>' . my_encode($product['name']) . '</name>' . PHP_EOL;
      echo '    <category>' . my_encode($product['category']) . '</category>' . PHP_EOL;
      echo '    <qunit>' . my_encode($product['products_vpe_name']) . '</qunit>' . PHP_EOL;
      echo '    <vatname>' . my_encode($product['tax_description']) . '</vatname>' . PHP_EOL;

      // Export the product attributes
      if ($product['attributes']) {
        $subindex = 0;
        foreach ($product['attributes'] as $attribute) {
          echo '    <attribute ';
          echo 'prefix="' . my_encode($product['attributes'][$subindex]['prefix']) . '" ';
          echo 'price="' . my_encode($product['attributes'][$subindex]['price']) . '" ';
          echo '>' . PHP_EOL;
          echo '     <option>' . my_encode($product['attributes'][$subindex]['option']) . '</option>' . PHP_EOL;
          echo '     <value>' . my_encode($product['attributes'][$subindex]['value']) . '</value>' . PHP_EOL;
          echo '    </attribute>' . PHP_EOL;
          $subindex ++;
        }
      }

      echo '   </item>' . PHP_EOL;
    }

    // Get the shipping       
    $totals_query = xtc_db_query("SELECT title,
                                         text,
                                         class
                                    FROM orders_total
                                   WHERE orders_id = '" . (int) $oID . "'
                                     AND class = 'ot_shipping'
                                ORDER BY sort_order
                                 ");
    $shipping_title = "";
    $shipping_text = "";
    if ($totals = xtc_db_fetch_array($totals_query)) {
      $shipping_title = $totals['title'];
      $shipping_text = $totals['text'];
    }

    // delete last character, if it is a ":"
    if (substr($shipping_title, -1, 1) == ':') {
      $shipping_title = substr($shipping_title, 0, -1);
    }

    if (strrpos($shipping_title, '(')) {
      $shipping_title = trim(substr($shipping_title, 0, strrpos($shipping_title, '(')));
    }

    $shipping_tax = 0.0;
    $shipping_tax_name = "";
    $shipping_class = $shippingssynonym[$shipping_title];
    if (!empty($shipping_class)) {
      $configkey = 'MODULE_SHIPPING_' . strtoupper($shipping_class) . '_TAX_CLASS';
      $tax_class = $configuration_array[$configkey];
      $orders_tax_query = xtc_db_query("SELECT tax_rate,
                                               tax_description
                                          FROM tax_rates
                                         WHERE tax_class_id = '" . $tax_class . "'
                                       ");
      if ($taxs = xtc_db_fetch_array($orders_tax_query)) {
        $shipping_tax = $taxs['tax_rate'];
        $shipping_tax_name = $taxs['tax_description'];
      }
    }

    $shipping_value = 0.0;
    if (preg_match("/[0-9]+\.[0-9]+/", str_replace(",", ".", $shipping_text), $matches))
      $shipping_value = $matches[0];

    // Get the COD fee      
    $totals_query = xtc_db_query("SELECT title,
                                         text,
                                         class
                                    FROM orders_total
                                   WHERE orders_id = '" . (int) $oID . "'
                                     AND class = 'ot_cod_fee'
                                ORDER BY sort_order
                                 ");
    $cod_fee_text = "";
    if ($totals = xtc_db_fetch_array($totals_query)) {
      $cod_fee_text = $totals['text'];
    }
    $cod_fee_value = 0.0;
    if (preg_match("/[0-9]+\.[0-9]+/", str_replace(",", ".", $cod_fee_text), $matches)) {
      $cod_fee_value = $matches[0];
    }

    // Workaround: add the COD fee to the shipping value
    $shipping_value += $cod_fee_value;

    echo '   <shipping ';
    echo 'gross="' . my_encrypt(number_format($shipping_value, 2)) . '" ';
//        echo 'net="' .number_format( $shipping_value / ( 1 + $shipping_tax/100), 2).'" ';
    echo 'vatpercent="' . my_encrypt(number_format($shipping_tax, 2)) . '">' . PHP_EOL;
    echo '    <name>' . my_encode($shipping_title) . '</name>' . PHP_EOL;
    echo '    <vatname>' . my_encode($shipping_tax_name) . '</vatname>' . PHP_EOL;
    echo '   </shipping>' . PHP_EOL;



    echo '   <payment ';
    echo 'type="' . my_encode($payment_text) . '" ';
    echo 'total="' . my_encrypt(number_format($total, 2, '.', '')) . '">' . PHP_EOL;
    echo '    <name>' . my_encode($order->info['payment_method']) . '</name>' . PHP_EOL;
    echo '   </payment>' . PHP_EOL;



    echo '  </order>' . PHP_EOL . PHP_EOL;
  }
}
echo ' </orders>' . PHP_EOL;


echo '</webshopexport>' . PHP_EOL;

